//package halos;

//import simu.*;
import java.math.*;
import java.util.Vector;
import geometrie.*;

import halos.*;

import java.awt.image.*;
import java.io.*;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.Color;

/**
 * classe Halos
 * applet calculant des halos atmosphriques par simulation des interactions de cristaux de glace avec la lumire du soleil
 */
 
public class Debug {
    
    static BufferedImage create_image(double rr[][],double vv[][],double bb[][], double vmax) {
        
        double max=0;
        int RR, VV, BB, c;
        int taille = rr.length;
        BufferedImage img = new BufferedImage(taille, taille, BufferedImage.TYPE_INT_RGB);
        Graphics g = ((Image)img).getGraphics();
        
        for (int i=0; i<taille; i++) {
            for (int j=0; j<taille; j++) {
                rr[i][j] = Math.log(rr[i][j]+1);
                vv[i][j] = Math.log(vv[i][j]+1);
                bb[i][j] = Math.log(bb[i][j]+1);
            }
        }
        
        for (int i=0; i<taille; i++) {
            for (int j=0; j<taille; j++) {
                if (rr[i][j]>max) max=rr[i][j];
                if (vv[i][j]>max) max=vv[i][j];
                if (bb[i][j]>max) max=bb[i][j];
            }
        }
        
        if (max==0) max=1;
        
        for (int i=0; i<taille; i++) {
            for (int j=0; j<taille; j++) {
                RR = (int)Math.floor(rr[i][j]/max*vmax);
                VV = (int)Math.floor(vv[i][j]/max*vmax);
                BB = (int)Math.floor(bb[i][j]/max*vmax);
                //c=RR*256*256+VV*256+BB;
                if (RR<0) System.out.println(rr[i][j]);
                g.setColor(new Color(RR,VV,BB));
                g.drawLine(taille-i-1,taille-j-1,taille-i-1,taille-j-1);
                //img.setRGB(i,j,c);
            }
        }
        
        return img;
    }
    
    static void addPoints(Image img, int[][] point, Color[] couleur, int taille) {
        Graphics g = (img).getGraphics();
        for(int i=0; i<taille; i++) {
            for(int j=0; j<taille; j++) {
                if (point[i][j]!=0) {
                    g.setColor(couleur[point[i][j]-1]);
                    g.drawLine(taille-i-1,taille-j-1,taille-i-1,taille-j-1);
                }
            }
        }
    }
    
    static BufferedImage create_image(Cristal c, Point[] liste, int taille_image) {
        
        BufferedImage img = new BufferedImage(taille_image, taille_image, BufferedImage.TYPE_INT_RGB);
        Graphics g = ((Image)img).getGraphics();
        g.translate(taille_image/2, taille_image/2);
        
        double facteur = -taille_image/(c.get_rayon()*2)*2./3;  //signe - pour rtablir les axes
        int x1, y1, x2, y2;
        
        g.setColor(new Color(0,255,0));
        c.draw(g, facteur);
        g.setColor(new Color(255,0,0));
        for (int i=0; i<liste.length-1; i++) {
            x1 = (int)Math.floor(liste[i].get_y()*facteur);
            y1 = (int)Math.floor(liste[i].get_z()*facteur);
            x2 = (int)Math.floor(liste[i+1].get_y()*facteur);
            y2 = (int)Math.floor(liste[i+1].get_z()*facteur);
            g.drawLine(x1,y1,x2,y2);
        }
        
        return img;
    }
    
    
    static double log10 = Math.log(10.);                                       //pour le logarithme dcimal
    
    static double hauteur, zoom;                                               //hauteur du soleil et zoom pour l'affichage
    static int taille_image = 512;                                             //taille de la zone d'affichage en pixels
    //static double [][] tableau = new double[taille_image][taille_image];       //tableau contenant les donnes calcules
    //static double [][] tableau_aff = new double[taille_image][taille_image];   //tableau contenant les donnes affiches
    static int [] histo = new int[181];                                        //histogramme des valeurs des angles calculs
    static double [] histo_aff = new double[181];                              //histogramme des valeurs des angles affichs
    
    static double Rt;                                                          //rayon terrestre
    static double altitude_nuages;                                             //altitude des nuages de glace
    static double atm;                                                         //distance des nuages au centre de la Terre en rayons terrestres
    
    //static Point P = new Point();                                              //point pour la projection
    static Point I = new Point();                                              //point d'intersection des rayons dans les nuages
    static Point O;                                                            //coordonnes du centre de la Terre
    static Point V = new Point(0, 0, 0);                                       //coordonnes de l'observateur
    static Vecteur u, v = new Vecteur();                                       //vecteurs des rayons solaire et ligne de vise de l'observateur

    static int type_cristal;                                                   //type de cristal etudi
    static double facteur_forme;                                               //facteur de forme du cristal
    static int nb_reflexions;                                                  //nombre de rflexions internes supplmentaires imposes
    static int type_histo;                                                     //type d'histogramme : 0 rien, 1 centr sur le soleil, 2 centr sur le zenith

    static double azimut_centre, hauteur_centre;                               //centre de la projection

    static double facteur_zoom;

    static double [][][] tableau = new double[3][taille_image][taille_image];  //tableau contenant l'image calcule
    static boolean reinitialiser;                                              //indique si l'image et l'histogramme doivent tre rinitialiss

    static Vecteur v0 = new Vecteur(0,0,-1);                                   //vecteur du rayon de rfrence pour les calculs de rfraction
    static Angles3 angles_c = new Angles3();                                   //angles d'orientation du cristal

    static Point2D P = new Point2D();;                                         //Point pour les calculs de projection

    static Cristal c;                                                          //Cristal tudi
    static Rayon r;                                                            //Rayon test

    static double R, R2;                                                       //la rayon et diamtre du cristal tudi

    static int type_aleatoire;                                                 //type de fonction alatoire pour le cristal : 0 alatoire, 1 "plate", 2 "column", 3 "column2"

    static double[] indices = new double[3];                                   //indices du milieu, pour quelques longueurs d'onde donnes

    static double azimut_centre_cercles, hauteur_centre_cercles, pas_cercles;  //donnes pour les cercles
    static int[][] points_cercle = new int[taille_image][taille_image];        //liste de points pour affichage des cecles (1) et sous l'horizon (2)
    static Color[] couleurs_cercle = {new Color(255,255,255), new Color(0,0,20), new Color(255, 255, 0)};     //couleurs associes

    static boolean tracer_cercles, cacher_horizon;                             //choix de l'utilisateur pour l'affichage des cercles et de l'image sous l'horizon
    static int nb_rayons;                                                      //nombre de rayons par itration
    static boolean afficher_soleil;                                            //choix de l'affichage du soleil

    static double cos_imax;                                                    //cos de l'angle de la Terre vu d'un cristal

    /*Vecteur vecteur_y = new Vecteur(0,1,0);
    Angles projection;
    double xmin=-1, xmax=1, ymin=-1, ymax=1;
    int echantillonage=256;*/
    
   /**
    * constructeur Halos 
    */
    /*public Halos() {
        appletDoc("halos_doc.xml");
    }*/
    
   /**
    * methode verifier 
    * verifie les paramtres entrs par l'utilisateur
    */
    public void verifier() {
        if (hauteur>90 || hauteur<-90) System.out.println("erreur");
        if (zoom>180) System.out.println("erreur");
    }
    
   /**
    * methode initCalculLive 
    * initialise l'applet
    * @param in liste des valeurs entres par l'utilisateur
    */
    /*public void initCalculLive(ListeValeurs in) throws SimuException {
        hauteur = in.lireDouble("hauteur")*Math.PI/180;
        zoom = in.lireDouble("zoom")*Math.PI/180;
        
        verifier();
        
        facteur_zoom = taille_image/(2*Math.sin(zoom/2));
        
        if (reinitialiser) {
        
            for (int i=0; i<taille_image; i++) {
                for(int j=0; j<taille_image; j++) {
                    for(int k=0; k<3; k++) {
                        tableau[k][i][j] = 0;
                    }
                    points_cercle[i][j] = 0;
                }
            }
            
            for (int i=0; i<histo.length; i++) histo[i] = 0;
        
        }
        
        u = new Vecteur(-Math.cos(hauteur), 0, -Math.sin(hauteur));
        
    }*/
    

    //public ListeValeurs calculLive() throws SimuException {
    
        //ListeValeurs out = new ListeValeurs();
    
public static void main(String[] args) {    
    
        ////
        //  lire en entre

int max=21;


for (int serie=11; serie<13; serie++) {

for (int num=0; num<max; num++) {

if (serie==3 || serie==5 || serie==7 || serie==11 || serie==12) hauteur_centre = 0;
if (serie==4 || serie==6 || serie==8 || serie==9 || serie==10) hauteur_centre = 90;

if (serie==3 || serie==4) type_aleatoire = 0;
if (serie==5 || serie==6) type_aleatoire = 1;
if (serie==7 || serie==8) type_aleatoire = 0;
if (serie==9 || serie==10) type_aleatoire = 0;
if (serie==1 || serie==12) type_aleatoire = 0;

if (serie>=3 && serie<=6) nb_reflexions = 0;
if (serie==7 || serie==8) nb_reflexions = 1;
if (serie==9) nb_reflexions = 1;
if (serie==10) nb_reflexions = 2;
if (serie==11) nb_reflexions = 1;
if (serie==12) nb_reflexions = 2;

if (serie<9) type_cristal = 1;
if (serie==9 || serie==10 || serie==11 || serie==12) type_cristal = 4; //goutte d'eau


        hauteur=-10+100*num/(max-1);

        //nb_reflexions = 0;
        //type_cristal = 1;
        facteur_forme = 1;
        //type_aleatoire = 2;
        type_histo = 1;
        azimut_centre = 0;              //0 pour le soleil, indp pour le zenith
        //hauteur_centre = 0;            //hauteur pour le soleil, 90 pour le zenith
        zoom = 180;
        indices[0] = 1.308;       //glace
        indices[1] = 1.313;
        indices[2] = 1.316;
        //double[] indices = {1.3318, 1.3360, 1.3417};  //eau     {1.308, 1.313, 1.316} //glace
        Rt = 6.4e6;
        altitude_nuages = 5000;
        azimut_centre_cercles = 0;
        hauteur_centre_cercles = 90;
        pas_cercles = 90;
        tracer_cercles = true;
        afficher_soleil = true;
        cacher_horizon = false;
        reinitialiser = true;
        nb_rayons = 10000000;
            

if (serie==11 || serie==12) {zoom=110; azimut_centre=180; cacher_horizon = true;}

           
        //  mettre dans init
        hauteur*=Math.PI/180;
        zoom*=Math.PI/180;
        azimut_centre*=Math.PI/180;
        hauteur_centre*=Math.PI/180;
        azimut_centre_cercles*=Math.PI/180;
        hauteur_centre_cercles*=Math.PI/180;
        pas_cercles*=Math.PI/180;
        u = new Vecteur(-Math.cos(hauteur), 0, -Math.sin(hauteur));
        facteur_zoom = taille_image/(2*Math.sin(zoom/2));
        c = new Cristal(type_cristal, facteur_forme, 1.3);
        R = c.get_rayon(); R2=R*2;
        r = new Rayon(v0, new Point(0,0,R2), 1);
        atm = (Rt+altitude_nuages)/Rt;
        cos_imax = Math.sqrt(1-1/atm/atm);
        O = new Point(0, 0, -Rt);
        
        if (reinitialiser) {
        
            for (int i=0; i<taille_image; i++) {
                for(int j=0; j<taille_image; j++) {
                    for(int k=0; k<3; k++) {
                        tableau[k][i][j] = 0;
                    }
                    points_cercle[i][j] = 0;
                }
            }
            
            for (int i=0; i<histo.length; i++) histo[i] = 0;
        
        }

        if (tracer_cercles) {
            int X,Y;
            Vecteur tmp = new Vecteur();
            for (double i=pas_cercles; i<=Math.PI; i+=pas_cercles) {
                for (double j=0; j<6.4; j+=zoom/taille_image/2) {
                    tmp.set_euler(i, j);
                    tmp.rotated_y(Math.PI/2-hauteur_centre_cercles);
                    tmp.rotated_z(azimut_centre_cercles);
                    P = projection(azimut_centre, hauteur_centre, tmp.get_phi(), Math.PI/2-tmp.get_theta(), facteur_zoom);
                    if (P == null) continue;
                    X=(int)Math.floor(P.get_x()+taille_image/2);
                    Y=(int)Math.floor(P.get_y()+taille_image/2);
                    if (X>=0 && Y>=0 && X<taille_image && Y<taille_image) points_cercle[X][Y] = 1;
                }
            }
        }

        if (afficher_soleil) {
            int X,Y;
            double i = 0.25 * Math.PI / 180;
            Vecteur tmp = new Vecteur();
                for (double j=0; j<6.4; j+=zoom/taille_image/2) {
                    tmp.set_euler(i, j);
                    tmp.rotated_y(Math.PI/2-hauteur);
                    P = projection(azimut_centre, hauteur_centre, tmp.get_phi(), Math.PI/2-tmp.get_theta(), facteur_zoom);
                    if (P == null) continue;
                    X=(int)Math.floor(P.get_x()+taille_image/2);
                    Y=(int)Math.floor(P.get_y()+taille_image/2);
                    //System.out.println(X+" "+Y);
                    //break;
                    if (X>=0 && Y>=0 && X<taille_image && Y<taille_image) {points_cercle[X][Y] = 3;};
                }
        }        
        
        if (cacher_horizon) {
            for(int i=0; i<taille_image; i++) {
                for(int j=0; j<taille_image; j++) {
                    if (Math.PI/2-de_projection_orthographique(azimut_centre, hauteur_centre, i, j, taille_image, zoom).get_theta()<0) {points_cercle[i][j]=2;};
                }
            }
        }
        ////
    
        double K, xp, yp, zp, cos_gamma, cos_theta, theta;
        int X, Y;

        int k;
        double x=0,y=0;
        
        for (int i=0;i<nb_rayons;i++) {
            do {
                if (type_aleatoire==0) angles_c.random();
                if (type_aleatoire==1) angles_c.random_plate(0.4);
                if (type_aleatoire==2) angles_c.random_column(0.4);
                if (type_aleatoire==3) angles_c.random_column2(0.4);
                c.oriente(angles_c);
//nb_reflexions=(int)Math.floor((Math.random())*2)+1; //choix alatoire du nombre de rflexions internes
                k=(int)Math.floor((Math.random())*3);
                c.set_indice(indices[k]); //choix alatoire des couleurs
                do {
                    x=(Math.random()-0.5)*R2;
                    y=(Math.random()-0.5)*R2;
                } while (x*x+y*y>R*R);
                r.set_P(x, y, R2);
                v = c.vecteur_sortie(r, hauteur-Math.PI/2, nb_reflexions);
            } while (v.norme()<0.1); //ie norme(v) = 0, le rayon n'a pas atteint le cristal ou il y a eu un problme lors du calcul
//System.out.println(Math.acos(v.scalaire(v0))*180/Math.PI); //angle sortie

//if (Math.acos(v.scalaire(v0))*180/Math.PI>90) continue;
        
            if (v.get_theta()>0.99*Math.PI) continue; //rayon non dvi

            if (type_histo==1) histo[(int)(Math.acos(v.scalaire(v0))*180/Math.PI)] ++; // si histogramme centr autour du soleil

            v.rotated_y(Math.PI/2-hauteur);
            
            if (type_histo==2) histo[(int)(Math.acos(v.scalaire(v0))*180/Math.PI)] ++; // si histogramme centr autour du zenith
            
            v.oppose();
            
            theta = v.get_theta();
            cos_theta = Math.cos(theta);
            I = V.translate(v.fois(Rt*(Math.sqrt(cos_theta*cos_theta+atm*atm-1)-cos_theta)));
            
            cos_gamma = u.scalaire(O.vecteur(I)) / (Rt * atm);
            if (cos_gamma>cos_imax) continue;                   //rayon solaire cach par la Terre
            //cos_gamma=1;
        
            // projette v et ajoute cos_gamma  l'histogramme si c'est dans l'cran
            //P = projection(Math.PI/180*0, hauteur, v.get_phi(), Math.PI/2-v.get_theta(), 256);
            //P = projection(0, Math.PI/2, v.get_phi(), Math.PI/2-v.get_theta(), 256);
            P = projection(azimut_centre, hauteur_centre, v.get_phi(), Math.PI/2-v.get_theta(), facteur_zoom);
            if (P == null) continue;
            X=(int)Math.floor(P.get_x()+taille_image/2);
            Y=(int)Math.floor(P.get_y()+taille_image/2);
            if (X>=0 && Y>=0 && X<taille_image && Y<taille_image) tableau[k][X][Y] += Math.abs(cos_gamma);
            //System.out.println(X+" "+Y);
       }


    BMPImage rgb = new BMPImage();
    BufferedImage img = create_image(tableau[0], tableau[1], tableau[2], 200);
    addPoints(img, points_cercle, couleurs_cercle, taille_image);
    rgb.writeBMP(img, "serie"+serie+"img"+num+".bmp");
    System.out.println("serie"+serie+"img"+num+" OK");

    }
}
/*    double dtheta=Math.PI/10, dphi=Math.PI/20, dpsi=Math.PI/30;

        c.oriente(angles_c);
        c.set_reference();
        Point[] liste = c.trajectoire(r, 0, nb_reflexions);
        
        for (int j=0; j<0; j++) {
        
        for (int i=0; i<liste.length; i++) {
            liste[i].rotated_z(j*dpsi);
            liste[i].rotated_y(j*dtheta);
            liste[i].rotated_z(j*dphi);
        }
        
        rgb.writeBMP(create_image(c, liste, 256), "test"+j+".bmp");
        
        for (int i=0; i<liste.length; i++) {
            liste[i].rotated_z(-j*dphi);
            liste[i].rotated_y(-j*dtheta);
            liste[i].rotated_z(-j*dpsi);
        }
        
        c.tourne(dtheta,dphi,dpsi);
        
    }


try {     
PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("hist.out")));
    
        for (int i=0; i<histo.length; i++) {
            out.print(i); out.print(" "); out.print(histo[i]); out.println();
        }
        
        out.close();
} catch (IOException ex) { System.out.println("erreur d'criture "+ex.getMessage()); }*/

        //out.ajouter("tableau", tableau_aff);
        //return out;
    }
   

    static Angles de_projection_orthographique(double azimut_centre, double hauteur_centre, double X, double Y, double taille, double Zoom) {
    
        //double K = Math.abs(Math.sin(Zoom/2-hauteur_centre));
        double K = 2*Math.sin(Zoom/2)/taille;
    
        double x = (X-taille/2)*K;
        double y = (Y-taille/2)*K;
        
        double rho = Math.sqrt(x*x+y*y);
        double c = Math.asin(rho);
        double ha = Math.asin(Math.cos(c)*Math.sin(hauteur_centre)+y*Math.cos(hauteur_centre));
        double az = azimut_centre + Math.atan(x/(Math.cos(hauteur_centre)*Math.cos(c) - y*Math.sin(hauteur_centre)));
    
    //System.out.println(x+" "+y+" "+rho+" "+(taille/2)+" "+c);
    
        return new Angles(Math.PI/2-ha, az);
    }
    
    /*Angles de_projection_lambert(double azimut_centre, double hauteur_centre, double X, double Y, double taille, double Zoom) {
    
        double K = Math.abs(Math.sin(Zoom/2-hauteur_centre));
    
        double x = (X-taille/2)*2*K/taille;
        double y = (Y-taille/2)*2*K/taille;
    
        double q = Math.sqrt(x*x+y*y)*signe(y);
        double az = Math.asin(x/q);
        double ha = Math.PI/2 - 2*Math.asin(q/2);
    
        return new Angles(Math.PI/2-ha, az);
    }*/
    
   /**
    * methode projection 
    * retourne la projection orthoscopique des coordonnes donnes
    * @param azimut_centre      l'azimut situ au centre de la projection
    * @param hauteur_centre     la hauteur situ au centre de la projection
    * @param azimut             l'azimut  projeter
    * @param hauteur            la hauteur  projeter
    * @param facteur            le facteur de conversion (li au zoom souhait)
    * @return la projection orthoscopique des coordonnes donnes
    */
    static public Point2D projection(double azimut_centre, double hauteur_centre, double azimut, double hauteur, double facteur) {
        if (Math.sin(hauteur_centre)*Math.sin(hauteur)+Math.cos(hauteur_centre)*Math.cos(hauteur)*Math.cos(azimut-azimut_centre)<0) return null;
        double x=facteur*Math.cos(hauteur)*Math.sin(azimut-azimut_centre);
        double y=facteur*(Math.cos(hauteur_centre)*Math.sin(hauteur)-Math.sin(hauteur_centre)*Math.cos(hauteur)*Math.cos(azimut-azimut_centre));
        return new Point2D(x, y);
    }
    
   /*
    Point projection_mercator(double azimut_centre, double azimut, double  hauteur, double taille, double hauteur_max) {
    //System.out.println(Math.log((1+Math.sin(hauteur))/(1-Math.sin(hauteur)))/ymax*taille);
    
        double ymax = Math.log((1+Math.sin(hauteur_max))/(1-Math.sin(hauteur_max)));
        double x = taille*((azimut - azimut_centre)%(2*Math.PI))/(2*Math.PI);
        double y = taille*Math.log((1+Math.sin(hauteur))/(1-Math.sin(hauteur)))/ymax;
        return new Point(x, y, 0);
    }*/

   /**
    * methode signe 
    * retourne le signe d'une variable
    * @param x valeur  tester
    * @return le signe de la variable
    */
    public double signe(double x) {
        if (x>0) return 1;
        if (x<0) return -1;
        return 0;
    }
    
}

