package geometrie;

import java.math.*;
import java.io.*;

/**
 * classe Angles
 * classe reprsentant les angles theta et phi ncessaire au positionnement 3D
 */
 
public class Angles {
    
    private double theta, phi; //angles
    
   /**
    * constructeur Angles
    * construit un Angles avec 0 comme valeurs par dfaut
    */
    public Angles() {
        theta=0; phi=0;
    }
    
   /**
    * constructeur Angles
    * construit un Angles avec les paramtres spcifis
    * @param theta_ l'angle theta
    * @param phi_   l'angle phi
    */
    public Angles(double theta_, double phi_) {
        theta=theta_; phi=phi_;
    }
    
   /**
    * methode get_theta
    * retourne l'angle theta
    * @return l'angle theta
    */
    public double get_theta() {return theta;}

   /**
    * methode get_phi
    * retourne l'angle phi
    * @return l'angle phi
    */
    public double get_phi() {return phi;}
    
   /**
    * methode set_theta
    * permet de modifier l'angle theta
    * @param v l'angle theta
    */
    public void set_theta(double v) {theta=v;}

    /**
    * methode set_theta
    * permet de modifier l'angle phi
    * @param v l'angle phi
    */
    public void set_phi(double v) {phi=v;}

   /**
    * methode random
    * gnre des angles alatoires pour theta ( rpartition de cos(theta) uniforme ) et phi (rpartition uniforme), soit une gnration alatoire sur une sphre
    */
    public void random() {
        theta = Math.acos(Math.random()*2-1);
        phi = Math.random()*2*Math.PI;
    }
    
   /**
    * methode affiche
    * affiche les angles theta et phi
    */
    public void affiche() {
        System.out.println(theta+" "+phi);
    }

   /**
    * methode print
    * enregistre les angles theta et phi dans le flux spcifi
    * @param out flux de sortie
    */
    public void print(PrintWriter out) {
        out.print(theta); out.print(" "); out.print(phi); out.println();
    }

}
