package geometrie;

import java.io.*;

/**
 * classe FormeGeometrique
 * classe abstraite reprsentant une forme gomtrique, dans le cas le plus gnral
 */
 
abstract public class FormeGeometrique {

   /**
    * constructeur FormeGeometrique
    * construit un objet abstrait FormeGeometrique
    */
    public FormeGeometrique() {
    
    }

   /**
    * methode affiche
    * affiche les paramtres de la forme gomtrique
    */
    abstract public void affiche();

   /**
    * methode print
    * enregistre les paramtres de la forme gomtrique dans le flux spcifi
    * @param out flux de sortie
    */
    abstract public void print(PrintWriter out);

   /**
    * methode rotated_z
    * tourne la forme 3D d'un angle donn autour de l'axe z
    * @param angle l'angle de rotation
    */
    abstract public void rotated_z(double angle);

   /**
    * methode signe
    * retourne le signe de la variable
    * @param x la variable a tester
    * @return le signe de la variable
    */
    public double signe(double x) {
        if (x>0) return 1;
        if (x<0) return -1;
        return 0;
    }

}