package geometrie;

/**
 * classe Hexagone
 * classe reprsentant un hexagone dans l'espace
 */
 
public class Hexagone extends Polygone {

    private double arete;   //longueur d'une arte de l'hexagone
    
   /**
    * constructeur Hexagone 
    * construit un hexagone avec les paramtres spcifis
    * @param arete_     la longueur d'un ct
    * @param centre     le centre de l'hexagone
    * @param n_         la normale  l'hexagone
    */
    public Hexagone(double arete_, Point centre, Vecteur n_) {
        super(centre, n_);
        arete=arete_;
        calculeCoins();
    }
    
   /**
    * methode calculeCoins
    * calcule la position de chaque coin en fonction des paramtres de l'hexagone
    */
    protected void calculeCoins() {
        Vecteur OP = (new Point(0,0,0)).vecteur(P);
        coins = new Point[6];
        double phi = n.get_phi();
        double theta = n.get_theta();
        for (int i=0;i<6; i++) {
            coins[i] = new Point(arete*Math.cos(i*Math.PI/3), arete*Math.sin(i*Math.PI/3), 0); //calcul dans le plan z=0
            coins[i].rotated_y(theta); coins[i].rotated_z(phi); //on tourne
            coins[i].translated(OP); //et on translate
        }
    }

}