package geometrie;

import java.math.*;
import java.io.*;

/**
 * classe Point2D
 * classe reprsentant un point dans un plan
 */
 
public class Point2D {
    
    private double x,y; //les coordonnes du point
    
   /**
    * constructeur Point 
    * construit un Point avec 0 comme coordonnes par dfaut
    */
    public Point2D() {
        x=0; y=0;
    }
    
   /**
    * constructeur Point 
    * construit un Point avec les coordonnes spcifies
    * @param x_ la coordonne x
    * @param y_ la coordonne y
    */
    public Point2D(double x_, double y_) {
        x=x_; y=y_;
    }
    
   /**
    * constructeur Point 
    * construit un Point  partir d'un Point 3D, en supprimant la coordonne selon z
    * @param P le point 3D  convertir
    */
    public Point2D(Point P) {
        x = P.get_x();
        y = P.get_y();
    }

   /**
    * methode get_x
    * retourne la valeur de la coordonne x
    * @return la valeur de la coordonne x
    */
    public double get_x() {return x;}
    
   /**
    * methode get_y
    * retourne la valeur de la coordonne y
    * @return la valeur de la coordonne y
    */
    public double get_y() {return y;}
    
   /**
    * methode set_x
    * permet de modifier la coordonne x
    * @param v la valeur de la coordonne x
    */
    public void set_x(double v) {x=v;}

   /**
    * methode set_y
    * permet de modifier la coordonne y
    * @param v la valeur de la coordonne y
    */
    public void set_y(double v) {y=v;}
    
   /**
    * methode set
    * permet de modifier les coordonnes du point
    * @param x_ la valeur de la coordonne x
    * @param y_ la valeur de la coordonne y
    */
    public void set(double x_, double y_) {
        x=x_; y=y_;
    }

   /**
    * methode set
    * permet de copier les coordonnes x et y d'un Point3D
    * @param P le point3D  convertir
    */
    public void set(Point P) {
        System.out.println("x = "+x);
        x = P.get_x();
        System.out.println("x = "+x);
        y = P.get_y();
    }

   /**
    * methode rotated
    * tourne le point d'un angle donn (autour de l'axe z)
    * @param angle l'angle de rotation
    */
    public void rotated(double angle) {
        double X = x;
        x=X*Math.cos(angle)+y*Math.sin(angle);
        y=y*Math.cos(angle)-X*Math.sin(angle);
    }

   /**
    * methode distance
    * retourne la distance  un autre point
    * @param B l'autre point
    * @return la distance  l'autre point
    */
    public double distance(Point2D B) {
        return Math.sqrt((x-B.get_x())*(x-B.get_x())+(y-B.get_y())*(y-B.get_y()));
    }

   /**
    * methode affiche
    * affiche les coordonnes
    */
    public void affiche() {
        System.out.println(x+" "+y);
    }

   /**
    * methode print
    * enregistre les coordonnes dans le flux spcifi
    * @param out flux de sortie
    */
    public void print(PrintWriter out) {
        out.print(x); out.print(" "); out.print(y); out.println();
    }

}
