package geometrie;

/**
 * classe Rectangle
 * classe reprsentant un rectangle dans l'espace
 */
 
public class Rectangle extends Polygone {

    private double longueur, largeur; //longueur et largeur du rectangle
    
   /**
    * constructeur Rectangle 
    * construit un rectangle avec les paramtres spcifis
    * @param longueur_  la longueur du rectangle
    * @param largeur_   la largeur du rectangle
    * @param centre     le centre du rectangle
    * @param n_         la normale au rectangle
    */
    public Rectangle(double longueur_, double largeur_, Point centre, Vecteur n_) {
        super(centre, n_);
        largeur=largeur_;
        longueur=longueur_;
        calculeCoins();
    }
    
   /**
    * methode calculeCoins
    * calcule la position de chaque coin en fonction des paramtres du rectangle
    */
    protected void calculeCoins() {
        //On considre un rectangle dans le plan z=0
        Vecteur OP = (new Point(0,0,0)).vecteur(P);
        double phi = n.get_phi();
        double theta = n.get_theta();
        coins = new Point[4];
        coins[0] = new Point(longueur/2., largeur/2., 0);
        coins[1] = new Point(-longueur/2., largeur/2., 0);
        coins[2] = new Point(-longueur/2., -largeur/2., 0);
        coins[3] = new Point(longueur/2., -largeur/2., 0);

        //On tourne puis on translate
        for (int i=0; i<4; i++) {
            coins[i].rotated_y(theta);
            coins[i].rotated_z(phi);
            coins[i].translated(OP);
        }
    }

}